import itertools
from collections import namedtuple
from typing import List
from utils import read_json
from teilfach_maker import make_teilfach

Fach = namedtuple("Fach", ["ectspfad", "notenpfad", "streichbar"])

# das hier und die files auf die verwiesen wird, edit me
faecher_config = {
    "haupt": Fach(ectspfad="ects/coli75.json", notenpfad="noten/coli.json", streichbar=24),
    "neben": Fach(ectspfad="ects/info25.json", notenpfad="noten/info.json", streichbar=8),
}

def main(args: List):

    for name, fach in faecher_config.items():
        ects = read_json(fach.ectspfad)
        noten = read_json(fach.notenpfad)
        streichbare_pkte = fach.streichbar

        teilfach = make_teilfach(ects, noten, streichbare_pkte)

        # TODO entscheidung von den einzelnen teilfächern abhängig machen
        scorelist = []
        for vektor in itertools.product([0, 1], repeat=10):
            score = teilfach.get_grade([0]+list(vektor)+[1, 1]) # TODO OP & BA sind gehardcodet
            scorelist.append((score[0], score[1], [0]+list(vektor)+[1, 1]))

        scorelist=sorted(scorelist)
        for score, score2, vektor in scorelist[:10]:
            print(score, score2, vektor)
        best_vektor = scorelist[0][2]
        punkte = scorelist[0][1]
        grade = scorelist[0][0]
        print(f"Optimal solution for {punkte} points found with grade {grade}")
        for module, value in zip(teilfach.module, best_vektor):
            #print(key, value)
            if value==0 and module.name!="Orientierungsprüfung":
                print("Pls remove " + module.name )

        break # TODO: andere jsons ausfüllen


    print(teilfach.get_grade([0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]))


if __name__ == "__main__":
    import sys
    args = sys.argv[1:]
    sys.exit(main(args))
