# lies ects ein und mach teilfach objekt draus

from modular.modulhandbuch import Kurs, Modul, Teilfach

from typing import Dict, Optional, Union


def make_teilfach(ects:Dict[str,Union[Dict[str,int],int]], noten:Dict[str,float], streichbare_pkte:int=0):
    # geht durch ects und nimmt die noten für die in noten was eingetragen ist
    # und macht ein teilfach objekt draus

    debugnoten = set(noten.keys()) - set(ects.keys())
    assert debugnoten == set(), f"Für {debugnoten} wurden Noten, aber keine ECTS angegeben :("

    module = []
    for modulname, modul in ects.items():

        # ist wert wieder dict oder int?
        if type(modul) is not dict:
            ects = modul# ECTS wert

            # ist note angegeben?
            modulnote = noten.get(modulname, False)
            if modulnote:
                module += [Modul(modulname,
                [Kurs(name=modulname, note=modulnote, ects=ects)]
                )]
        else:
            kurse = []
            for kursname, kursects in modul.items():
                kursnote = noten[modulname].get(kursname, False)
                if kursnote:
                    kurse += [Kurs(name=kursname, note=kursnote, ects=kursects)]
        
                    
    teilfach = Teilfach(module, streichbare_pkte=streichbare_pkte)
    return teilfach

